Package org.jfree.layouting.renderer.text

## Class DefaultRenderableTextFactory

- java.lang.Object
- - org.jfree.layouting.renderer.text.DefaultRenderableTextFactory

- All Implemented Interfaces:
    `RenderableTextFactory`, `StatefullComponent`

      public class DefaultRenderableTextFactory
      extends java.lang.Object
      implements RenderableTextFactory

  For the sake of completeness, we would now also need a script-type classifier and from there we would need a BaseLineInfo-factory.
  Author:
    Thomas Morgner

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `protected static class` | `DefaultRenderableTextFactory.DefaultRenderableTextFactoryState` |

  - ### Constructor Summary

    Constructors
    Modifier | Constructor | Description
    --- | --- | ---
    `` | `DefaultRenderableTextFactory​(LayoutProcess layoutProcess)` |
    `protected` | `DefaultRenderableTextFactory​(LayoutProcess layoutProcess, boolean init)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `protected void` | `addGlyph​(int rawCodePoint, int[] extraChars)` |
    `protected void` | `addWord​(boolean forceLinebreak)` |
    `protected org.pentaho.reporting.libraries.fonts.text.breaks.BreakOpportunityProducer` | `createBreakProducer​(LayoutContext layoutContext)` |
    `protected org.pentaho.reporting.libraries.fonts.text.font.FontSizeProducer` | `createFontSizeProducer​(LayoutContext layoutContext)` |
    `protected org.pentaho.reporting.libraries.fonts.text.classifier.GlyphClassificationProducer` | `createGlyphClassifier​(LayoutContext layoutContext)` |
    `protected org.pentaho.reporting.libraries.fonts.text.font.KerningProducer` | `createKerningProducer​(LayoutContext layoutContext)` |
    `protected org.pentaho.reporting.libraries.fonts.text.SpacingProducer` | `createSpacingProducer​(LayoutContext layoutContext)` |
    `RenderNode[]` | `createText​(int[] text, int offset, int length, LayoutContext layoutContext)` | The text is given as CodePoints.
    `protected org.pentaho.reporting.libraries.fonts.text.whitespace.WhiteSpaceFilter` | `createWhitespaceFilter​(LayoutContext layoutContext)` |
    `RenderNode[]` | `finishText​()` |
    `protected RenderNode[]` | `processText​(int[] text, int offset, int length)` |
    `State` | `saveState​()` |
    `void` | `startText​()` |

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DefaultRenderableTextFactory

          public DefaultRenderableTextFactory​(LayoutProcess layoutProcess)

    - #### DefaultRenderableTextFactory

          protected DefaultRenderableTextFactory​(LayoutProcess layoutProcess,
                                                 boolean init)

  - ### Method Detail

    - #### createText

          public RenderNode[] createText​(int[] text,
                                         int offset,
                                         int length,
                                         LayoutContext layoutContext)

      Description copied from interface: `RenderableTextFactory`
      The text is given as CodePoints.
      Specified by:
        `createText` in interface `RenderableTextFactory`
      Returns:

    - #### processText

          protected RenderNode[] processText​(int[] text,
                                             int offset,
                                             int length)

    - #### addGlyph

          protected void addGlyph​(int rawCodePoint,
                                  int[] extraChars)

    - #### addWord

          protected void addWord​(boolean forceLinebreak)

    - #### createWhitespaceFilter

          protected org.pentaho.reporting.libraries.fonts.text.whitespace.WhiteSpaceFilter createWhitespaceFilter​(LayoutContext layoutContext)

    - #### createGlyphClassifier

          protected org.pentaho.reporting.libraries.fonts.text.classifier.GlyphClassificationProducer createGlyphClassifier​(LayoutContext layoutContext)

    - #### createBreakProducer

          protected org.pentaho.reporting.libraries.fonts.text.breaks.BreakOpportunityProducer createBreakProducer​(LayoutContext layoutContext)

    - #### createSpacingProducer

          protected org.pentaho.reporting.libraries.fonts.text.SpacingProducer createSpacingProducer​(LayoutContext layoutContext)

    - #### createFontSizeProducer

          protected org.pentaho.reporting.libraries.fonts.text.font.FontSizeProducer createFontSizeProducer​(LayoutContext layoutContext)

    - #### createKerningProducer

          protected org.pentaho.reporting.libraries.fonts.text.font.KerningProducer createKerningProducer​(LayoutContext layoutContext)

    - #### finishText

          public RenderNode[] finishText​()

      Specified by:
        `finishText` in interface `RenderableTextFactory`

    - #### startText

          public void startText​()

      Specified by:
        `startText` in interface `RenderableTextFactory`

    - #### saveState

          public State saveState​()
                          throws StateException

      Specified by:
        `saveState` in interface `StatefullComponent`
      Throws:
        `StateException`